#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

using namespace std;

typedef long long ll;

const int K = 9;
const int S = 11;
const int MAXN = K * (1 << 17);

int sz = 1;
int nxt[MAXN][S];
ll cnt[MAXN];

void add(const string &s, int id) {
	int cur = 0;
	for (char c : s) {
		if (nxt[cur][c - '0'] == -1) {
			nxt[cur][c - '0'] = sz++;
		}
		cur = nxt[cur][c - '0'];
	}
}

void rec(const string &s, int v, int x, int add) {
	if (v == -1) return;
	if (x == K) {
		cnt[v] += add;
		return;
	}
	for (int y = 0; '0' + y < s[x]; y++) {
		if (nxt[v][y] != -1) {
			cnt[nxt[v][y]] += add;
		}
	}
	rec(s, nxt[v][s[x] - '0'], x + 1, add);
	if (nxt[v][10] != -1) {
		cnt[nxt[v][10]] += add * (s[x] - '0');
		rec(s, nxt[v][10], x + 1, add * 1);
	}
}	

int main() {
	freopen("queries.in", "r", stdin);
	freopen("queries.out", "w", stdout);

	int n, m;
	while (cin >> n >> m) {
		memset(nxt, -1, sizeof(nxt));

		vector<string> a(n), b(m);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			a[i] = string(K - a[i].length(), '0') + a[i];
		}
		for (int i = 0; i < m; i++) {
			cin >> b[i];
			b[i] = string(K - b[i].length(), '0') + b[i];
			for (int j = 0; j < K; j++) if (b[i][j] == '?') b[i][j] = '0' + 10;
		}

		for (int i = 0; i < m; i++) {
			add(b[i], i);
		}
		for (int i = 0; i < n; i++) {
			rec(a[i], 0, 0, 1);
		}
		for (int i = 0; i < m; i++) {
			int cur = 0;
			vector<int> vct;
			for (int c : b[i]) {
				cur = nxt[cur][c - '0'];
				vct.push_back(cur);
			}
			ll cans = 0;
			int pw = 1;
			for (int j = K - 1; j >= 0; j--) {
				cans += cnt[vct[j]] * pw;
				if (b[i][j] == '9' + 1) pw *= 10;
			}
			cout << cans << "\n";
		}
	}

	return 0;
}